CPU:
    subClassOf: ['HardwareSpec']
    prefix: 'gax-core'
    attributes:
    -
        title: 'cpuArchitecture'
        prefix: 'gax-core'
        dataType: 'xsd:string'  ## controlled vocabulary
        cardinality:
          minCount: 0
          maxCount: 1
        description: 'Basic CPU architecture.'
        exampleValues: [ 'x86', 'x86-64', 'RISC-V', 'Generic']
    -
        title: 'cpuGeneration'
        prefix: 'gax-core'
        dataType: 'xsd:string'  ## controlled vocabulary
        cardinality:
          minCount: 0
          maxCount: 1
        description: 'CPU instruction set generation. Determines basic feature set and migration compatibility.'
        exampleValues: [ 'Skylake-Server-v4', 'Icelake-Server-v4', 'Cascadelake-Server-v4', 'EPYC-Milan-v1', 'EPYC-Rome-v2' ]
    -
        title: 'cpuFlag'
        prefix: 'gax-service'
        dataType: 'xsd:string'
        cardinality:
          minCount: 0
        description: 'CPU flags as documented by lscpu and defined in https://github.com/torvalds/linux/blob/master/tools/arch/x86/include/asm/cpufeatures.h.'
        exampleValues:  ['fpu', 'vme', 'de', 'pse', 'sse', 'sse2', 'ht', 'vmx', 'smx', 'sse4_1', 'sse4_2', 'avx', '3dnowprefetch', 'ibrs_enhanced', 'ept_ad', 'sgx', 'sgx_lc', 'md_clear', 'arch_capabilities', ... ]
    -
        title: 'smtIsEnabled'
        prefix: 'gax-service'
        dataType: 'xsd:boolean'
        cardinality: '0..1'
        description: 'Is simultaneous multithreading (SMT) or hyper threading (HT) active in this CPU? Default False.'
        exampleValues: ['true', 'false']

    -   title: 'numberOfCores'
        prefix: 'gax-core'
        dataType: 'xsd:integer'
        cardinality: '0..1'
        description: 'Number of Cores of the CPU'
        exampleValues: [ '4', '6', '8', '12', '24' ]

    -   title: 'numberOfThreads'
        prefix: 'gax-core'
        dataType: 'xsd:integer'
        cardinality: '0..1'
        description: 'Number of Threads of the CPU'
        exampleValues: [ '8', '12', '24' ]

    -   title: 'frequency'
        prefix: 'gax-core'
        dataType: 'gax-core:Measure'
        cardinality: '0..1'
        description: 'Frequency of the CPU'
        exampleValues: [ A structure object of type measure, e.g. measure:value=3.0 and measure:unit=GHz' ]

    -   title: 'boostFrequency'
        prefix: 'gax-core'
        dataType: 'gax-core:Measure'
        cardinality: '0..1'
        description: 'Boost frequency of the CPU'
        exampleValues: [ A structure object of type measure, e.g. measure:value=4.0 and measure:unit=GHz' ]

    -   title: 'cacheSize'
        prefix: 'gax-core'
        dataType: 'gax-core:Measure'
        cardinality: '0..1'
        description: 'Cache size of the CPU'
        exampleValues: [ A structure object of type measure, e.g. measure:value=38 and measure:unit=MB'' ]

    -   title: 'allowedSocket'
        prefix: 'gax-core'
        dataType: 'xsd:string'
        cardinality: '0..1'
        description: 'Socket the CPU fits into.'
        exampleValues: [ 'FCLGA3647' ]
